ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.37 by greg, Thu Jun 14 22:42:21 2012 UTC vs.
Revision 2.54 by greg, Wed Mar 25 22:50:48 2015 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10   use File::Temp qw/ :mktemp  /;
11   sub userror {
12 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-W][-t{3|4} Nlog2][-r \"ropts\"][-f \"x=string;y=string\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}C][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13          exit 1;
14   }
15 < my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
16 < chomp $td;
15 > my ($td,$radscn,$mgfscn,$octree,$fsender,$bsender,$receivers,$facedat,$behinddat,$rmtmp);
16 > my ($tf,$rf,$tb,$rb,$tfx,$rfx,$tbx,$rbx,$tfz,$rfz,$tbz,$rbz);
17 > if ($windoz) {
18 >        my $tmploc = `echo \%TMP\%`;
19 >        chomp($tmploc);
20 >        $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
21 >        $radscn = "$td\\device.rad";
22 >        $mgfscn = "$td\\device.mgf";
23 >        $octree = "$td\\device.oct";
24 >        $fsender = "$td\\fsender.rad";
25 >        $bsender = "$td\\bsender.rad";
26 >        $receivers = "$td\\receivers.rad";
27 >        $facedat = "$td\\face.dat";
28 >        $behinddat = "$td\\behind.dat";
29 >        $tf = "$td\\tf.dat";
30 >        $rf = "$td\\rf.dat";
31 >        $tb = "$td\\tb.dat";
32 >        $rb = "$td\\rb.dat";
33 >        $tfx = "$td\\tfx.dat";
34 >        $rfx = "$td\\rfx.dat";
35 >        $tbx = "$td\\tbx.dat";
36 >        $rbx = "$td\\rbx.dat";
37 >        $tfz = "$td\\tfz.dat";
38 >        $rfz = "$td\\rfz.dat";
39 >        $tbz = "$td\\tbz.dat";
40 >        $rbz = "$td\\rbz.dat";
41 >        chomp $td;
42 >        $rmtmp = "rmdir /S /Q $td";
43 > } else {
44 >        $td = mkdtemp("/tmp/genBSDF.XXXXXX");
45 >        chomp $td;
46 >        $radscn = "$td/device.rad";
47 >        $mgfscn = "$td/device.mgf";
48 >        $octree = "$td/device.oct";
49 >        $fsender = "$td/fsender.rad";
50 >        $bsender = "$td/bsender.rad";
51 >        $receivers = "$td/receivers.rad";
52 >        $facedat = "$td/face.dat";
53 >        $behinddat = "$td/behind.dat";
54 >        $tf = "$td/tf.dat";
55 >        $rf = "$td/rf.dat";
56 >        $tb = "$td/tb.dat";
57 >        $rb = "$td/rb.dat";
58 >        $tfx = "$td/tfx.dat";
59 >        $rfx = "$td/rfx.dat";
60 >        $tbx = "$td/tbx.dat";
61 >        $rbx = "$td/rbx.dat";
62 >        $tfz = "$td/tfz.dat";
63 >        $rfz = "$td/rfz.dat";
64 >        $tbz = "$td/tbz.dat";
65 >        $rbz = "$td/rbz.dat";
66 >        $rmtmp = "rm -rf $td";
67 > }
68   my @savedARGV = @ARGV;
69 + my $rfluxmtx = "rfluxmtx -ab 5 -ad 700 -lw 3e-6";
70 + my $wrapper = "wrapBSDF";
71   my $tensortree = 0;
72   my $ttlog2 = 4;
73   my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
74   my $mgfin = 0;
75   my $geout = 1;
76   my $nproc = 1;
77 + my $docolor = 0;
78   my $doforw = 0;
79   my $doback = 1;
80   my $pctcull = 90;
81 < my $gunit = "Meter";
81 > my $gunit = "meter";
82 > my $curspec = "Visible";
83   my @dim;
84   # Get options
85   while ($#ARGV >= 0) {
86          if ("$ARGV[0]" =~ /^[-+]m/) {
87                  $mgfin = ("$ARGV[0]" =~ /^\+/);
88          } elsif ("$ARGV[0]" eq "-r") {
89 <                $rtargs = "$rtargs $ARGV[1]";
89 >                $rfluxmtx .= " $ARGV[1]";
90                  shift @ARGV;
91          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
92                  $geout = ("$ARGV[0]" =~ /^\+/);
# Line 40 | Line 95 | while ($#ARGV >= 0) {
95                          die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
96                  }
97                  shift @ARGV;
98 +        } elsif ("$ARGV[0]" =~ /^[-+]C/) {
99 +                $docolor = ("$ARGV[0]" =~ /^\+/);
100          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
101                  $doforw = ("$ARGV[0]" =~ /^\+/);
102          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
# Line 52 | Line 109 | while ($#ARGV >= 0) {
109                  $tensortree = substr($ARGV[0], 2, 1);
110                  $ttlog2 = $ARGV[1];
111                  shift @ARGV;
112 +        } elsif ("$ARGV[0]" eq "-f") {
113 +                $wrapper .= " -f \"$ARGV[1]\"";
114 +                shift @ARGV;
115 +        } elsif ("$ARGV[0]" eq "-W") {
116 +                $wrapper .= " -W";
117          } elsif ("$ARGV[0]" eq "-c") {
118                  $nsamp = $ARGV[1];
119                  shift @ARGV;
# Line 71 | Line 133 | while ($#ARGV >= 0) {
133   }
134   # Check that we're actually being asked to do something
135   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
136 + # Issue warning for unhandled reciprocity case
137 + print STDERR "Warning: recommend both +forward and +backward with -t3\n" if
138 +                ($tensortree==3 && !($doforw && $doback));
139 + $wrapper .= $tensortree ? " -a t$tensortree" : " -a kf -c";
140 + $wrapper .= " -u $gunit";
141   # Get scene description and dimensions
75 my $radscn = "$td/device.rad";
76 my $mgfscn = "$td/device.mgf";
77 my $octree = "$td/device.oct";
142   if ( $mgfin ) {
143 <        system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
143 >        system "mgf2rad @ARGV > $radscn";
144          die "Could not load MGF input\n" if ( $? );
81        system "mgf2rad $mgfscn > $radscn";
145   } else {
146          system "xform -e @ARGV > $radscn";
147          die "Could not load Radiance input\n" if ( $? );
85        system "rad2mgf $radscn > $mgfscn" if ( $geout );
148   }
149   if ($#dim != 5) {
150          @dim = split ' ', `getbbox -h $radscn`;
151   }
152   print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
153 < # Add receiver surfaces (rectangular)
154 < my $fmodnm="receiver_face";
93 < my $bmodnm="receiver_behind";
94 < open(RADSCN, ">> $radscn");
95 < print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
96 < print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
97 < print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
98 < print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
99 < close RADSCN;
153 > $wrapper .= ' -f "t=' . ($dim[5] - $dim[4]) . ';w=' . ($dim[1] - $dim[0]) .
154 >                ';h=' . ($dim[3] - $dim[2]) . '"';
155   # Generate octree
156   system "oconv -w $radscn > $octree";
157   die "Could not compile scene\n" if ( $? );
158 < # Output XML prologue
104 < print
105 < '<?xml version="1.0" encoding="UTF-8"?>
106 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 < ';
108 < print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 < print
110 < '<WindowElementType>System</WindowElementType>
111 < <Optical>
112 < <Layer>
113 <        <Material>
114 <                <Name>Name</Name>
115 <                <Manufacturer>Manufacturer</Manufacturer>
116 < ';
117 < printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 < printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
119 < printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
120 < print "\t\t<DeviceType>Integral</DeviceType>\n";
121 < # Output MGF description if requested
158 > # Add MGF description if requested
159   if ( $geout ) {
160 <        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
161 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
125 <        open(MGFSCN, "< $mgfscn");
126 <        while (<MGFSCN>) { print $_; }
160 >        open(MGFSCN, "> $mgfscn");
161 >        printf MGFSCN "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
162          close MGFSCN;
163 <        print "xf\n";
164 <        print "\t\t</Geometry>\n";
163 >        if ( $mgfin ) {
164 >                system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV >> $mgfscn};
165 >        } else {
166 >                system "rad2mgf $radscn >> $mgfscn";
167 >        }
168 >        open(MGFSCN, ">> $mgfscn");
169 >        print MGFSCN "xf\n";
170 >        close MGFSCN;
171 >        $wrapper .= " -g $mgfscn";
172   }
173 < print " </Material>\n";
174 < # Set up surface sampling
175 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
134 < my $ny = int($nsamp/$nx + .5);
173 > # Create receiver & sender surfaces (rectangular)
174 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
175 > my $ny = int($nsamp/$nx + 1);
176   $nsamp = $nx * $ny;
177   my $ns = 2**$ttlog2;
178 < my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
178 > open(RADSCN, "> $receivers");
179 > print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=sc$ns\n" : "h=kf\n");
180 > print RADSCN '#@rfluxmtx ' . "u=Y o=$facedat\n\n";
181 > print RADSCN "void glow receiver_face\n0\n0\n4 1 1 1 0\n\n";
182 > print RADSCN "receiver_face source f_receiver\n0\n0\n4 0 0 1 180\n\n";
183 > print RADSCN '#@rfluxmtx ' . "u=Y o=$behinddat\n\n";
184 > print RADSCN "void glow receiver_behind\n0\n0\n4 1 1 1 0\n\n";
185 > print RADSCN "receiver_behind source b_receiver\n0\n0\n4 0 0 -1 180\n";
186 > close RADSCN;
187 > # Finish rfluxmtx command and prepare sender surfaces
188 > $rfluxmtx .= " -n $nproc -c $nsamp";
189 > if ( $tensortree != 3 ) {       # Isotropic tensor tree is exception
190 >        open (RADSCN, "> $fsender");
191 >        print RADSCN '#@rfluxmtx u=Y ' . ($tensortree ? "h=sc$ns\n\n" : "h=kf\n\n");
192 >        print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
193 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[2], $dim[4];
194 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[3], $dim[4];
195 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[3], $dim[4];
196 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[2], $dim[4];
197 >        close RADSCN;
198 >        open (RADSCN, "> $bsender");
199 >        print RADSCN '#@rfluxmtx u=Y ' . ($tensortree ? "h=sc$ns\n\n" : "h=kf\n\n");
200 >        print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
201 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[2], $dim[5];
202 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[2], $dim[5];
203 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[3], $dim[5];
204 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[3], $dim[5];
205 >        close RADSCN;
206 > }
207 > # Calculate CIE (u',v') from Radiance RGB:
208 > my $CIEuv =     'Xi=.5141*Ri+.3239*Gi+.1620*Bi;' .
209 >                'Yi=.2651*Ri+.6701*Gi+.0648*Bi;' .
210 >                'Zi=.0241*Ri+.1229*Gi+.8530*Bi;' .
211 >                'den=Xi+15*Yi+3*Zi;' .
212 >                'uprime=4*Xi/den;vprime=9*Yi/den;' ;
213   # Create data segments (all the work happens here)
214   if ( $tensortree ) {
215          do_tree_bsdf();
216   } else {
217          do_matrix_bsdf();
218   }
219 < # Output XML epilogue
220 < print
221 < '</Layer>
222 < </Optical>
223 < </WindowElement>
224 < ';
219 > # Output XML
220 > my $old_fh = select(STDOUT);
221 > $| = 1;
222 > select($old_fh);
223 > print "<!-- Created by: genBSDF @savedARGV -->\n";
224 > # print STDERR "Running: $wrapper\n";
225 > system $wrapper;
226 > die "Could not wrap BSDF data\n" if ( $? );
227   # Clean up temporary files and exit
228 < exec("rm -rf $td");
228 > exec $rmtmp;
229  
230   #-------------- End of main program segment --------------#
231  
232   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
233   sub do_tree_bsdf {
157 # Shirley-Chiu mapping from unit square to disk
158 $sq2disk = '
159 in_square_a = 2*in_square_x - 1;
160 in_square_b = 2*in_square_y - 1;
161 in_square_rgn = if(in_square_a + in_square_b,
162                        if(in_square_a - in_square_b, 1, 2),
163                        if(in_square_b - in_square_a, 3, 4));
164 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
165                        -in_square_a, -in_square_b);
166 out_disk_phi = PI/4 * select(in_square_rgn,
167                                in_square_b/in_square_a,
168                                2 - in_square_a/in_square_b,
169                                4 + in_square_b/in_square_a,
170                                if(in_square_b*in_square_b,
171                                        6 - in_square_a/in_square_b, 0));
172 Dx = out_disk_r*cos(out_disk_phi);
173 Dy = out_disk_r*sin(out_disk_phi);
174 Dz = sqrt(1 - out_disk_r*out_disk_r);
175 ';
176 # Shirley-Chiu mapping from unit disk to square
177 $disk2sq = '
178 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
179 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
180 in_disk_phi = norm_radians(atan2(Dy, Dx));
181 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
182 out_square_a = select(in_disk_rgn,
183                        in_disk_r,
184                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
185                        -in_disk_r,
186                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
187 out_square_b = select(in_disk_rgn,
188                        in_disk_phi*in_disk_r/(PI/4),
189                        in_disk_r,
190                        (PI - in_disk_phi)*in_disk_r/(PI/4),
191                        -in_disk_r);
192 out_square_x = (out_square_a + 1)/2;
193 out_square_y = (out_square_b + 1)/2;
194 ';
195 # Announce ourselves in XML output
196 print "\t<DataDefinition>\n";
197 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
198 print "\t</DataDefinition>\n";
234  
235 < # Start rcontrib processes for compute each side
236 < do_tree_rtcontrib(0) if ( $doback );
237 < do_tree_rtcontrib(1) if ( $doforw );
235 >        # Run rfluxmtx processes to compute each side
236 >        do_ttree_dir(0) if ( $doback );
237 >        do_ttree_dir(1) if ( $doforw );
238  
239   }       # end of sub do_tree_bsdf()
240  
241 < # Run rcontrib process in background to generate tensor tree samples
242 < sub do_tree_rtcontrib {
241 > # Call rfluxmtx and process tensor tree BSDF for the given direction
242 > sub do_ttree_dir {
243          my $forw = shift;
244 <        my $matargs = "-m $bmodnm";
210 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
211 <        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
212 <                "-e '$disk2sq' -bn '$ns*$ns' " .
213 <                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
214 <                "-o $td/%s.flt $matargs $octree";
244 >        my $cmd;
245          if ( $tensortree == 3 ) {
246                  # Isotropic BSDF
247                  my $ns2 = $ns / 2;
248 <                $cmd = "cnt $ns2 $ny $nx " .
249 <                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
250 <                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
251 <                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
252 <                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
253 <                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
254 <                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
255 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
256 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
257 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
258 <                        "| $cmd";
248 >                if ($windoz) {
249 >                        $cmd = "cnt $ns2 $ny $nx " .
250 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
251 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
252 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
253 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
254 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
255 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
256 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
257 >                                qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
258 >                                qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
259 >                                "| $rfluxmtx -fa -y $ns2 - $receivers -i $octree";
260 >                } else {
261 >                        $cmd = "cnt $ns2 $ny $nx " .
262 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
263 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
264 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
265 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
266 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
267 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
268 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
269 >                                qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
270 >                                qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
271 >                                "| $rfluxmtx -h -ff -y $ns2 - $receivers -i $octree";
272 >                }
273          } else {
274                  # Anisotropic BSDF
275 <                # Sample area vertically to improve load balance, since
276 <                # shading systems usually have bilateral symmetry (L-R)
277 <                $cmd = "cnt $ns $ns $ny $nx " .
278 <                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
279 <                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
280 <                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
237 <                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
238 <                        "-e 'in_square_x=(\$1+r1)/$ns' " .
239 <                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
240 <                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
241 <                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
242 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
243 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
244 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
245 <                        "| $cmd";
275 >                my $sender = ($bsender,$fsender)[$forw];
276 >                if ($windoz) {
277 >                        $cmd = "$rfluxmtx -fa $sender $receivers -i $octree";
278 >                } else {
279 >                        $cmd = "$rfluxmtx -h -ff $sender $receivers -i $octree";
280 >                }
281          }
282 < # print STDERR "Starting: $cmd\n";
283 <        system "$cmd" || die "Failure running rcontrib";
282 >        # print STDERR "Starting: $cmd\n";
283 >        system $cmd;
284 >        die "Failure running rfluxmtx" if ( $? );
285          ttree_out($forw);
286 < }       # end of do_tree_rtcontrib()
286 > }       # end of do_ttree_dir()
287  
288 < # Simplify and output tensor tree results
288 > # Simplify and store tensor tree results
289   sub ttree_out {
290          my $forw = shift;
291 <        my $side = ("Back","Front")[$forw];
292 <        my $cmd;
293 < # Only output one transmitted distribution, preferring backwards
294 < if ( !$forw || !$doback ) {
295 < print
296 < '       <WavelengthData>
297 <                <LayerNumber>System</LayerNumber>
262 <                <Wavelength unit="Integral">Visible</Wavelength>
263 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
264 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
265 <                <WavelengthDataBlock>
266 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
267 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
268 <                        <ScatteringDataType>BTDF</ScatteringDataType>
269 <                        <ScatteringData>
270 < ';
271 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
272 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
273 < if ($pctcull >= 0) {
274 <        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
275 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
276 <        system "$cmd" || die "Failure running rttree_reduce";
277 < } else {
278 <        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
279 <        print "{\n";
280 <        system "$cmd" || die "Failure running rcalc";
281 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
282 <                print "0\n";
291 >        my ($refldat,$transdat);
292 >        if ( $forw ) {
293 >                $transdat = $facedat;
294 >                $refldat = $behinddat;
295 >        } else {
296 >                $transdat = $behinddat;
297 >                $refldat = $facedat;
298          }
299 <        print "}\n";
300 < }
301 < print
302 < '                       </ScatteringData>
303 <                </WavelengthDataBlock>
304 <        </WavelengthData>
305 < ';
306 < }
292 < # Output reflection
293 < print
294 < '       <WavelengthData>
295 <                <LayerNumber>System</LayerNumber>
296 <                <Wavelength unit="Integral">Visible</Wavelength>
297 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
298 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
299 <                <WavelengthDataBlock>
300 < ';
301 < print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
302 < print
303 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
304 <                        <ScatteringDataType>BRDF</ScatteringDataType>
305 <                        <ScatteringData>
306 < ';
307 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
308 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
309 < if ($pctcull >= 0) {
310 <        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
311 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
312 <        system "$cmd" || die "Failure running rttree_reduce";
313 < } else {
314 <        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
315 <        print "{\n";
316 <        system "$cmd" || die "Failure running rcalc";
317 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
318 <                print "0\n";
299 >        # Only output one transmitted anisotropic distribution, preferring backwards
300 >        if ( !$forw || !$doback || $tensortree==3 ) {
301 >                my $ttyp = ("tb","tf")[$forw];
302 >                ttree_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
303 >                if ( $docolor ) {
304 >                        ttree_comp($ttyp, "CIE-u", $transdat, ($tbx,$tfx)[$forw]);
305 >                        ttree_comp($ttyp, "CIE-v", $transdat, ($tbz,$tfz)[$forw]);
306 >                }
307          }
308 <        print "}\n";
309 < }
310 < print
311 < '                       </ScatteringData>
312 <                </WavelengthDataBlock>
313 <        </WavelengthData>
314 < ';
308 >        # Output reflection
309 >        my $rtyp = ("rb","rf")[$forw];
310 >        ttree_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
311 >        if ( $docolor ) {
312 >                ttree_comp($rtyp, "CIE-u", $refldat, ($rbx,$rfx)[$forw]);
313 >                ttree_comp($rtyp, "CIE-v", $refldat, ($rbz,$rfz)[$forw]);
314 >        }
315   }       # end of ttree_out()
316  
317 + # Call rttree_reduce on the given component
318 + sub ttree_comp {
319 +        my $typ = shift;
320 +        my $spec = shift;
321 +        my $src = shift;
322 +        my $dest = shift;
323 +        my $cmd;
324 +        if ($windoz) {
325 +                if ("$spec" eq "Visible") {
326 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
327 +                                q{-e "Ri=$1;Gi=$2;Bi=$3" } .
328 +                                qq{-e "$CIEuv" } .
329 +                                q{-e "$1=Yi/Omega"};
330 +                } elsif ("$spec" eq "CIE-u") {
331 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
332 +                                qq{-e "$CIEuv" } .
333 +                                q{-e "$1=uprime"};
334 +                } elsif ("$spec" eq "CIE-v") {
335 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
336 +                                qq{-e "$CIEuv" } .
337 +                                q{-e "$1=vprime"};
338 +                }
339 +        } else {
340 +                if ("$spec" eq "Visible") {
341 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
342 +                                q{-e 'Ri=$1;Gi=$2;Bi=$3' } .
343 +                                "-e '$CIEuv' " .
344 +                                q{-e '$1=Yi/Omega'};
345 +                } elsif ("$spec" eq "CIE-u") {
346 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
347 +                                "-e '$CIEuv' " .
348 +                                q{-e '$1=uprime'};
349 +                } elsif ("$spec" eq "CIE-v") {
350 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
351 +                                "-e '$CIEuv' " .
352 +                                q{-e '$1=vprime'};
353 +                }
354 +        }
355 +        if ($pctcull >= 0) {
356 +                my $avg = ( "$typ" =~ /^r[fb]/ ) ? " -a" : "";
357 +                my $pcull = ("$spec" eq "Visible") ? $pctcull :
358 +                                                     (100 - (100-$pctcull)/3) ;
359 +                if ($windoz) {
360 +                        $cmd = "rcollate -ho -oc 1 $src | " .
361 +                                        $cmd .
362 +                                        " | rttree_reduce$avg -h -fa -t $pcull -r $tensortree -g $ttlog2";
363 +                } else {
364 +                        $cmd .= " -of $src " .
365 +                                        "| rttree_reduce$avg -h -ff -t $pcull -r $tensortree -g $ttlog2";
366 +                }
367 +                # print STDERR "Running: $cmd\n";
368 +                system "$cmd > $dest";
369 +                die "Failure running rttree_reduce" if ( $? );
370 +        } else {
371 +                if ($windoz) {
372 +                        $cmd = "rcollate -ho -oc 1 $src | " . $cmd ;
373 +                } else {
374 +                        $cmd .= " $src";
375 +                }
376 +                open(DATOUT, "> $dest");
377 +                print DATOUT "{\n";
378 +                close DATOUT;
379 +                # print STDERR "Running: $cmd\n";
380 +                system "$cmd >> $dest";
381 +                die "Failure running rcalc" if ( $? );
382 +                open(DATOUT, ">> $dest");
383 +                for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
384 +                        print DATOUT "0\n";
385 +                }
386 +                print DATOUT "}\n";
387 +                close DATOUT;
388 +        }
389 +        if ( "$spec" ne "$curspec" ) {
390 +                $wrapper .= " -s $spec";
391 +                $curspec = $spec;
392 +        }
393 +        $wrapper .= " -$typ $dest";
394 + }       # end of ttree_comp()
395 +
396   #------------- End of do_tree_bsdf() & subroutines -------------#
397  
398   #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
399   sub do_matrix_bsdf {
400 < # Set up sampling of portal
401 < # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
402 < $tcal = '
403 < DEGREE : PI/180;
404 < sq(x) : x*x;
405 < Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
406 < Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
407 < Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
408 < Kmax : Kaccum(Knaz(0));
409 < Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
410 < Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
411 < Kcol = Kbin - Kaccum(Krow-1);
412 < Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
413 < Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
414 < sin_kpol = sin(Kpol);
415 < Dx = cos(Kazi)*sin_kpol;
416 < Dy = sin(Kazi)*sin_kpol;
417 < Dz = sqrt(1 - sin_kpol*sin_kpol);
418 < KprojOmega = PI * if(Kbin-.5,
419 <        (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
420 <        1 - sq(cos(Kpola(1)*DEGREE)));
421 < ';
422 < # Compute Klems bin from exiting ray direction (forward or backward)
423 < $kcal = '
424 < DEGREE : PI/180;
425 < abs(x) : if(x, x, -x);
426 < Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
427 < posangle(a) : if(-a, a + 2*PI, a);
361 < Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
362 < kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
363 < knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
364 < kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
365 < kfindrow(r, pol) : if(r-kpola(0)+.5, r,
366 <                if(pol-kpola(r), kfindrow(r+1, pol), r) );
367 < kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
368 < kbin2(pol,azi) = select(kfindrow(1, pol),
369 <                kazn(azi,360/knaz(1)),
370 <                kaccum(1) + kazn(azi,360/knaz(2)),
371 <                kaccum(2) + kazn(azi,360/knaz(3)),
372 <                kaccum(3) + kazn(azi,360/knaz(4)),
373 <                kaccum(4) + kazn(azi,360/knaz(5)),
374 <                kaccum(5) + kazn(azi,360/knaz(6)),
375 <                kaccum(6) + kazn(azi,360/knaz(7)),
376 <                kaccum(7) + kazn(azi,360/knaz(8)),
377 <                kaccum(8) + kazn(azi,360/knaz(9))
378 <        );
379 < kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
380 < ';
381 < my $ndiv = 145;
382 < # Compute scattering data using rcontrib
383 < my @tfarr;
384 < my @rfarr;
385 < my @tbarr;
386 < my @rbarr;
387 < my $cmd;
388 < my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
389 <        "-e '$kcal' -b kbin -bn $ndiv " .
390 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
391 < my $rccmd = "rcalc -e '$tcal' " .
392 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
393 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
394 < if ( $doforw ) {
395 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
396 <        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
397 <        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
398 <        "-e 'zp:$dim[4]' " .
399 <        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
400 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
401 <        "| $rtcmd";
402 < system "$cmd" || die "Failure running: $cmd\n";
403 < @tfarr = `$rccmd $td/$fmodnm.flt`;
404 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
405 < @rfarr = `$rccmd $td/$bmodnm.flt`;
406 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
407 < }
408 < if ( $doback ) {
409 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
410 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
411 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
412 <        "-e 'zp:$dim[5]' " .
413 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
414 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
415 <        "| $rtcmd";
416 < system "$cmd" || die "Failure running: $cmd\n";
417 < @tbarr = `$rccmd $td/$bmodnm.flt`;
418 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
419 < chomp(@tbarr);
420 < @rbarr = `$rccmd $td/$fmodnm.flt`;
421 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
422 < chomp(@rbarr);
423 < }
424 < # Output angle basis
425 < print
426 < '       <DataDefinition>
427 <                <IncidentDataStructure>Columns</IncidentDataStructure>
428 <                <AngleBasis>
429 <                        <AngleBasisName>LBNL/Klems Full</AngleBasisName>
430 <                        <AngleBasisBlock>
431 <                        <Theta>0</Theta>
432 <                        <nPhis>1</nPhis>
433 <                        <ThetaBounds>
434 <                                <LowerTheta>0</LowerTheta>
435 <                                <UpperTheta>5</UpperTheta>
436 <                        </ThetaBounds>
437 <                        </AngleBasisBlock>
438 <                        <AngleBasisBlock>
439 <                        <Theta>10</Theta>
440 <                        <nPhis>8</nPhis>
441 <                        <ThetaBounds>
442 <                                <LowerTheta>5</LowerTheta>
443 <                                <UpperTheta>15</UpperTheta>
444 <                        </ThetaBounds>
445 <                        </AngleBasisBlock>
446 <                        <AngleBasisBlock>
447 <                        <Theta>20</Theta>
448 <                        <nPhis>16</nPhis>
449 <                        <ThetaBounds>
450 <                                <LowerTheta>15</LowerTheta>
451 <                                <UpperTheta>25</UpperTheta>
452 <                        </ThetaBounds>
453 <                        </AngleBasisBlock>
454 <                        <AngleBasisBlock>
455 <                        <Theta>30</Theta>
456 <                        <nPhis>20</nPhis>
457 <                        <ThetaBounds>
458 <                                <LowerTheta>25</LowerTheta>
459 <                                <UpperTheta>35</UpperTheta>
460 <                        </ThetaBounds>
461 <                        </AngleBasisBlock>
462 <                        <AngleBasisBlock>
463 <                        <Theta>40</Theta>
464 <                        <nPhis>24</nPhis>
465 <                        <ThetaBounds>
466 <                                <LowerTheta>35</LowerTheta>
467 <                                <UpperTheta>45</UpperTheta>
468 <                        </ThetaBounds>
469 <                        </AngleBasisBlock>
470 <                        <AngleBasisBlock>
471 <                        <Theta>50</Theta>
472 <                        <nPhis>24</nPhis>
473 <                        <ThetaBounds>
474 <                                <LowerTheta>45</LowerTheta>
475 <                                <UpperTheta>55</UpperTheta>
476 <                        </ThetaBounds>
477 <                        </AngleBasisBlock>
478 <                        <AngleBasisBlock>
479 <                        <Theta>60</Theta>
480 <                        <nPhis>24</nPhis>
481 <                        <ThetaBounds>
482 <                                <LowerTheta>55</LowerTheta>
483 <                                <UpperTheta>65</UpperTheta>
484 <                        </ThetaBounds>
485 <                        </AngleBasisBlock>
486 <                        <AngleBasisBlock>
487 <                        <Theta>70</Theta>
488 <                        <nPhis>16</nPhis>
489 <                        <ThetaBounds>
490 <                                <LowerTheta>65</LowerTheta>
491 <                                <UpperTheta>75</UpperTheta>
492 <                        </ThetaBounds>
493 <                        </AngleBasisBlock>
494 <                        <AngleBasisBlock>
495 <                        <Theta>82.5</Theta>
496 <                        <nPhis>12</nPhis>
497 <                        <ThetaBounds>
498 <                                <LowerTheta>75</LowerTheta>
499 <                                <UpperTheta>90</UpperTheta>
500 <                        </ThetaBounds>
501 <                        </AngleBasisBlock>
502 <                </AngleBasis>
503 <        </DataDefinition>
504 < ';
505 < if ( $doforw ) {
506 < print
507 < '       <WavelengthData>
508 <                <LayerNumber>System</LayerNumber>
509 <                <Wavelength unit="Integral">Visible</Wavelength>
510 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
511 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
512 <                <WavelengthDataBlock>
513 <                        <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
514 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
515 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
516 <                        <ScatteringDataType>BTDF</ScatteringDataType>
517 <                        <ScatteringData>
518 < ';
519 < # Output front transmission (transposed order)
520 < for (my $od = 0; $od < $ndiv; $od++) {
521 <        for (my $id = 0; $id < $ndiv; $id++) {
522 <                print $tfarr[$ndiv*$id + $od], ",\n";
400 >
401 >        # Run rfluxmtx processes to compute each side
402 >        do_matrix_dir(0) if ( $doback );
403 >        do_matrix_dir(1) if ( $doforw );
404 >
405 > }       # end of sub do_matrix_bsdf()
406 >
407 > # Call rfluxmtx and process tensor tree BSDF for the given direction
408 > sub do_matrix_dir {
409 >        my $forw = shift;
410 >        my $cmd;
411 >        my $sender = ($bsender,$fsender)[$forw];
412 >        $cmd = "$rfluxmtx -fd $sender $receivers -i $octree";
413 >        # print STDERR "Starting: $cmd\n";
414 >        system $cmd;
415 >        die "Failure running rfluxmtx" if ( $? );
416 >        matrix_out($forw);
417 > }       # end of do_matrix_dir()
418 >
419 > sub matrix_out {
420 >        my $forw = shift;
421 >        my ($refldat,$transdat);
422 >        if ( $forw ) {
423 >                $transdat = $facedat;
424 >                $refldat = $behinddat;
425 >        } else {
426 >                $transdat = $behinddat;
427 >                $refldat = $facedat;
428          }
429 <        print "\n";
430 < }
431 < print
432 < '                       </ScatteringData>
433 <                </WavelengthDataBlock>
434 <        </WavelengthData>
530 <        <WavelengthData>
531 <                <LayerNumber>System</LayerNumber>
532 <                <Wavelength unit="Integral">Visible</Wavelength>
533 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
534 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
535 <                <WavelengthDataBlock>
536 <                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
537 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
538 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
539 <                        <ScatteringDataType>BRDF</ScatteringDataType>
540 <                        <ScatteringData>
541 < ';
542 < # Output front reflection (transposed order)
543 < for (my $od = 0; $od < $ndiv; $od++) {
544 <        for (my $id = 0; $id < $ndiv; $id++) {
545 <                print $rfarr[$ndiv*$id + $od], ",\n";
429 >        # Output transmission
430 >        my $ttyp = ("tb","tf")[$forw];
431 >        matrix_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
432 >        if ( $docolor ) {
433 >                matrix_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
434 >                matrix_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
435          }
436 <        print "\n";
437 < }
438 < print
439 < '                       </ScatteringData>
440 <                </WavelengthDataBlock>
441 <        </WavelengthData>
553 < ';
554 < }
555 < if ( $doback ) {
556 < print
557 < '       <WavelengthData>
558 <                <LayerNumber>System</LayerNumber>
559 <                <Wavelength unit="Integral">Visible</Wavelength>
560 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
561 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
562 <                <WavelengthDataBlock>
563 <                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
564 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
565 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
566 <                        <ScatteringDataType>BTDF</ScatteringDataType>
567 <                        <ScatteringData>
568 < ';
569 < # Output back transmission (transposed order)
570 < for (my $od = 0; $od < $ndiv; $od++) {
571 <        for (my $id = 0; $id < $ndiv; $id++) {
572 <                print $tbarr[$ndiv*$id + $od], ",\n";
436 >        # Output reflection
437 >        my $rtyp = ("rb","rf")[$forw];
438 >        matrix_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
439 >        if ( $docolor ) {
440 >                matrix_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
441 >                matrix_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
442          }
443 <        print "\n";
444 < }
445 < print
446 < '                       </ScatteringData>
447 <                </WavelengthDataBlock>
448 <        </WavelengthData>
449 <        <WavelengthData>
450 <                <LayerNumber>System</LayerNumber>
451 <                <Wavelength unit="Integral">Visible</Wavelength>
452 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
453 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
454 <                <WavelengthDataBlock>
455 <                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
456 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
457 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
589 <                        <ScatteringDataType>BRDF</ScatteringDataType>
590 <                        <ScatteringData>
591 < ';
592 < # Output back reflection (transposed order)
593 < for (my $od = 0; $od < $ndiv; $od++) {
594 <        for (my $id = 0; $id < $ndiv; $id++) {
595 <                print $rbarr[$ndiv*$id + $od], ",\n";
443 > }       # end of matrix_out()
444 >
445 > # Transpose matrix component data and save to file
446 > sub matrix_comp {
447 >        my $typ = shift;
448 >        my $spec = shift;
449 >        my $src = shift;
450 >        my $dest = shift;
451 >        my $cmd = "rmtxop -fa -t";
452 >        if ("$spec" eq "Visible") {
453 >                $cmd .= " -c 0.265 0.670 0.065";
454 >        } elsif ("$spec" eq "CIE-X") {
455 >                $cmd .= " -c 0.514 0.324 0.162";
456 >        } elsif ("$spec" eq "CIE-Z") {
457 >                $cmd .= " -c 0.024 0.123 0.853";
458          }
459 <        print "\n";
460 < }
461 < print
462 < '                       </ScatteringData>
463 <                </WavelengthDataBlock>
464 <        </WavelengthData>
465 < ';
466 < }
467 < }
468 < #------------- End of do_matrix_bsdf() --------------#
459 >        $cmd .= " $src | rcollate -ho -oc 145";
460 >        # print STDERR "Running: $cmd\n";
461 >        system "$cmd > $dest";
462 >        die "Failure running rttree_reduce" if ( $? );
463 >        if ( "$spec" ne "$curspec" ) {
464 >                $wrapper .= " -s $spec";
465 >                $curspec = $spec;
466 >        }
467 >        $wrapper .= " -$typ $dest";
468 > }       # end of matrix_comp()
469 >
470 > #------------- End of do_matrix_bsdf() & subroutines --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines